#!/usr/local/bin/ruby

print "Content-type: text/html\n\n\n"

require "../config.rb"
require "cgi-lib"
require "yaml"

CONFIG_FILENAME="../config.yml"

def load_config
	@configuration = {}
	config = config_flatten(File.open(CONFIG_FILENAME) {|f| YAML.load(f) })
	config.each_with_index {|h, i|
		h.reject! {|k, v| /\A[A-Z]/ !~ k }
		uri = h['URI']
		if @configuration.include? uri
			@configuration[uri].update h
			config[i] = nil
		else
			@configuration[uri] = h
		end
	}
	config.compact!
	config
end

def config_flatten(arr, default={})
	result = []
	arr.each {|elt|
		case elt
		when Hash
			if elt.include? 'URI'
				result << default.dup.update(elt)
			else
				default = default.dup.update(elt)
			end
		when Array
			result.concat config_flatten(elt, default)
		when String
			result << default.dup.update({'URI'=>elt})
		end
	}
	result
end


puts <<EOF;
<HTML>
      <BODY onload="setTimeout(&quot;location.href='#{EDIT_HTML}'&quot;,1000*3)">
EOF

OUTPUT_FILE=CONFIG_FILE

input = CGI.new

newURL=input["newURL"]
cat   =input["cat"]

if cat==""|| cat==nil
 cat="Etc"
end

newCategory=input["newCategory"]
newUpdateInfoURI=input["newUpdateInfoURI"]


#conf=YAML::load(open(CONFIG_FILE).read)
    conf = load_config

		
		h=Hash::new
		if newURL != nil && newURL !="" && newURL !="http://"

			puts newURL+"򥫥ƥ"+cat+"ɲäޤ<BR>"
			puts "<HR>"
			
			h["URI"]=newURL
			h["Category"]=cat
			
			
		elsif newUpdateInfoURI != nil && newUpdateInfoURI!="" && newUpdateInfoURI!="http://"
			
			puts newUpdateInfoURI+"ɲäޤ<BR>"
			puts "<HR>"
			
			h["URI"]=newUpdateInfoURI
			h["UpdateInfo"]="lirs"
			h["Periodical"]=true
			
		elsif newCategory != nil
			h["Category"]=newCategory	
    end
		if h!=nil 
			conf.push h
		end
fo=open(OUTPUT_FILE,'w')
fo.puts conf.to_yaml
fo.close


puts <<EOF;
3äۤɤȼưŪޤʤ<A HREF="#{EDIT_HTML}"></A>򥯥åƤ
</BODY>
</HTML>
EOF
