#!/usr/bin/env ruby
require 'main.rb'

require 'cgi'
require 'kconv'
require 'config'

class String
  # ܸޤü
  def jleft(len)
    return "" if len <= 0
    
    str = self[0, len]

    if str.count("\xa1-\xfe") % 2 == 1
      str[-1, 1] = ''
    end
    str
  end
end


class Entry

  def get_icon

    s=@status.dup
      euri = s['_log'][0]['extractedLinkURI']
      luri = s['_log'][0]['LinkURI']
      uri = s['_log'][0]['URI']
      uri=euri if euri!=nil 
      uri=luri if luri!=nil 
      baseuri=uri.sub(/(http\:\/\/.+?\/).*/,'\1')
    basename="./"+AutoFile.directory+"/icon/"+baseuri.sub(/http\:\/\//,'').gsub(/\//,'')
    local_icon_path=basename+".png"
    local_icon_ico =basename+".ico"

    # ե뤬ʤä顢äƤΤ񤭤ʤΤˡ
    begin
      fp=open(local_icon_path)
      fp.close
    rescue 

      icon_path=baseuri+"favicon.ico"
      begin
        fpr =open(icon_path)
        fpw=open(local_icon_ico,"w")
        fpw.puts fpr.read
        fpw.close
        fpr.close 
        
        if open(local_icon_ico).read =~ /html/ 
					raise "403"
				end
				
				com="convert +adjoin -geometry 16x16 "+local_icon_ico+" "+local_icon_path
        system(com)

        begin
          fp=open(local_icon_path)
          fp.close
        rescue  # ʣgifŸ줿硢*.gif.0 *.gifȤ롣
          com="cp "+local_icon_path+".0 "+local_icon_path
          system(com)
        end

      rescue  # ʤäconvert˼Ԥ
	#OpenURI::HTTPError 
        com="cp ./tmp/icon/tmp.png "+local_icon_path
        system(com)
      end
    end
    
    if local_icon_path!=nil
      local_icon_path="./"+local_icon_path
    end
    
    local_icon_path
  end
  
	
  def diff_contents
    log1, log2 = recent_log2
    return unless log1 && log2
    filename1 = log1['content'].pathname
    filename2 = log2['content'].pathname

    outtxt=""

    if log2['contentType'] !~ /html/
      tree2, checksum_filter2 = ignore_tree(HTree.parse(File.read(filename2).decode_charset_guess), log2)

      hashes=[]
      h=[]

      title=""
      
      tree2.make_loc.traverse_element do |n|
        path = n.path.sub(%r{^doc\(\)}, '')
#        c = n.to_node
        c = n.node
	
        if path=~ /rdf\:RDF\/item.*\/title/
          tmp= c.extract_text.to_s
          if title!=""
            htmp=[]
            htmp.push "title"
            htmp.push CGI::escapeHTML(title)
            htmp.push "description"
            htmp.push " "
            h.push Hash[*htmp]
          end
          title="["+tmp+"]"
        end
       
			 if ((
					(path =~ /content\:encoded/) ||
					(path =~ /rdf\:RDF\/item.*\/description/)
					 ) && title!="")
          text= c.extract_text.to_s
          text=text.gsub(/http:\/\/.*?\.html/,'').gsub(/http:\/\/.*?\.htm/,'').gsub(/http:\/\/.*?\//,'').gsub(/\<.*?\>/,'')
          
          htmp=[]
          htmp.push "title"
          htmp.push CGI::escapeHTML(title)
          htmp.push "description"
          htmp.push CGI::escapeHTML(text.jleft(DIFF_ROW-title.size))
          h.push Hash[*htmp]
          title=""
	
				end					
      
		
	
	
end
      
      h[0..(DIFF_COLUMNS-1)]
      
		else
			tree1, checksum_filter1 = ignore_tree(HTree.parse(File.read(filename1).decode_charset_guess), log1)
			tree2, checksum_filter2 = ignore_tree(HTree.parse(File.read(filename2).decode_charset_guess), log2)

			
		tf1 = Tempfile.new('htmldiff1')
    tf1.puts tree1.extract_text.to_s
    tf1.close

    tf2 = Tempfile.new('htmldiff2')
    tf2.puts tree2.extract_text.to_s
    tf2.close

			
			system("cp #{tf1.path} #{filename1}.hoge")
			system("cp #{tf2.path} #{filename2}.hoge")
			
			dif= `diff -u #{tf1.path} #{tf2.path}`.toeuc
			#.gsub(/\{elem .*\{text \"/,'').gsub(/\"\}\}$/,'')
			
      dif.scan(/^\+.*$/) do |l|
        l=l.gsub(/^\+\+\+.*?$/,'').gsub(/^\+/,'')
        if l !~ /^[\s\t\r\n]*$/
          outtxt+=l.chomp
        end
      end

      outtxt=outtxt.gsub(/\<.*?\>/,'').gsub(/\&lt\;.*?\&gt\;/,'').gsub(/\&nbsp\;/,'').gsub(/\n/,'').gsub(/\r/,'')
			#.gsub(/\\n/,'').gsub(/\\r/,'').gsub(/\\t/,'')


      title=""
      description=outtxt.jleft(DIFF_ROW*DIFF_COLUMNS)

      if description !~ /^\s*$/
        [{"title"=>CGI::escapeHTML(title),"description"=>CGI::escapeHTML(description)}]
      else
        nil
      end
    end
  end


  def presentation_data
    h = @config.dup
    logseq = @status['_log']
    h.update @status # xxx
    h['title'] = h['Title']
    h['author'] = h['Author']
    h['last-modified'] = nil
    h['info'] = ''
    h['linkURI'] = h['LinkURI']
    unless logseq.empty?
      if l = find_first_200_with_current_content
        h['last-modified-found'] = l['clientDateBeg'] # xxx: clientDateEnd is better?
        if l.include?('lastModifiedString') and
           begin
            h['last-modified'] = Time.httpdate_robust(l['lastModifiedString'])
           rescue
             false
           end
          h['last-modified'].localtime
          l2 = find_last_200
          unless l.equal? l2
            if l['lastModifiedString'] != l2['lastModifiedString']
              h['info'] << '[Touch]'
            else
              h['info'] << '[NoIMS]'
            end
          end
        elsif l.include? 'extractedLastModified'
          h['last-modified'] = l['extractedLastModified'].getlocal
        else
          h['last-modified'] = l['clientDateBeg'].getlocal
          h['info'] << '[NoLM]'
        end
        if l.include? 'baseURI'
          h['info'] << '[Redirect]'
        end
        h['title'] ||= l['extractedTitle'] if l['extractedTitle']
        h['author'] ||= l['extractedAuthor'] if l['extractedAuthor']
        h['linkURI'] ||= l['extractedLinkURI'] if l['extractedLinkURI']
      end
      if StatusMap[logseq.last['status']] == 'e'
        l = logseq.last
        if l['status']
          if l['statusMessage']
            h['info'] << "[#{l['status']} #{l['statusMessage']}]"
          else
            h['info'] = "[#{l['status']}]"
          end
        elsif l['trouble']
          h['info'] = "[#{l['trouble']}]"
        else
          h['info'] = '[no status]'
        end
      end
    end
    h['title'] ||= h['LinkURI'] if h['LinkURI']
    h['title'] ||= h['URI']
    h['linkURI'] ||= h['URI']

    # h['_log']ϡ0,1ݤ졢
    #ʤ2notModifiedʥȥ꤬褦
    #⤽ΤѤΤǤϤʤȤϻפʤ..
            
		if @status['_log'][1] 
	     if !@status['_log'][1]['diffContents'] && !(@status['_log'].frozen?)
				 @status['_log'][1]['diffContents']=self.diff_contents
			 end
			 h['diffContents']=@status['_log'][1]['diffContents']
		 end
	    
	    h['iconPath']=self.get_icon
			h['showhide']="JavaScript:showhide('"+h['URI']+"')"
						
			h
			
  end
end

class Samidare
	def main
    parse_options
    config = load_config
    if @opt_dump_config
      puts config.to_yaml
      return
    end
    data = nil
    readonly =
      @opt_timing ||
      @opt_dont_check ||
      @opt_dump_status ||
      @opt_dump_template_data ||
      @opt_dump_filenames ||
      @opt_dump_filenames2 ||
      @opt_diff_content
    open_status(readonly) {|status|
      entries = create_entries(config, status, readonly)
      if @opt_dump_status
        dump_status(status, entries)
      elsif @opt_dump_filenames
        dump_filenames(entries)
      elsif @opt_dump_filenames2
        dump_filenames2(entries)
      elsif @opt_diff_content
        diff_content(entries)
      elsif @opt_timing
        entries = entries.map {|entry|
          [entry.next_timing.localtime, entry]
        }.sort
        now = Time.now
        entries.each {|timing, entry|
          if now && timing > now
            puts "#{now}  --- now ---"
            now = nil
          end
          h = entry.presentation_data
          s = "#{timing}: #{h['title']}"
          s << " (#{h['Author']})" if h['Author']
          puts s
        }
	if now
	  puts "#{now}  --- now ---"
	end
      elsif @opt_remove_entry
        removing_uris = {}
        entries.each {|e|
          unless (e.related_uris & ARGV).empty? || e.status['_log'].empty?
            removing_uris[e.uri] = true
          end
        }
        status.reject! {|log|
          uri = log['URI']
          if removing_uris[uri]
            STDERR.puts "removed: #{uri}" if $VERBOSE
            true
          else
            false
          end
        }
      else
        unless readonly
          update_info_entries, non_update_info_entries = entries.partition {|e| e.update_info? }
          update_info_entries.concurrent_map {|entry|
            next unless entry.update_info?
            entry.check if entry.should_check? && (@opt_force_check || entry.timing_check)
          }
          non_update_info_entries.concurrent_map {|entry|
            next if entry.update_info?
            entry.check if entry.should_check? && (@opt_force_check || entry.timing_check)
          }
        end
        update_infos, entries = entries.partition {|entry| entry.update_info? }
        
				categories=[]
				config.each do |con|
					categories.push con['Category'].to_s
				end
				categories.uniq!
				categories-=[""]
						
				data = {
          "antenna" =>
          entries.map {|entry| entry.presentation_data }.sort_by {|h|
            # [h['last-modified'], h['title']]
            if h['last-modified-found']
              [2, h['last-modified-found'], h['last-modified'], h['title']]
            elsif h['last-modified']
              [1, h['last-modified'], h['title']]
            else
              [0, h['title']]
            end
          }.reverse,
          "update_info" =>
          update_infos.map {|update_info| update_info.presentation_data }.sort_by {|h|
            # [h['last-modified'], h['title']]
            if h['last-modified-found']
              [2, h['last-modified-found'], h['last-modified'], h['title']]
            elsif h['last-modified']
              [1, h['last-modified'], h['title']]
            else
              [0, h['title']]
            end
          }.reverse,
        "Categories" =>
            categories.map {|h|
							{"link"=> "category.html#"+h,
							 "link_k"=> "category_k.html#"+h,
							 "name"=> h}
					}.reverse,
				"antennaName"     =>ANTENNA_NAME,
				"antennaNameCat"  =>ANTENNA_NAME+"(ƥ)",
				"antennaNameEdit" =>ANTENNA_NAME+"(Խ)",
#				"antennaNameK"    =>ANTENNA_NAME,
#				"antennaNameKCat" =>ANTENNA_NAME+"(ƥ)"
			}
				
			
				if @opt_dump_template_data
          pp data
          return
        end
        generate_output(data)
        generate_lirs(data)
      end
    }
    #PP.pp(data, STDERR) if $VERBOSE
		end
	
  def generate_lirs(data)
    str = ''
    data["antenna"].each {|h|
      next unless h['last-modified'] && h['last-modified-found']
      #p ['LIRS', h['last-modified'], h['last-modified-found'], h['URI'], h['title'], h['author']]
      str << 'LIRS,'
      str << h['last-modified'].to_i.to_s << ','
      str << h['last-modified-found'].to_i.to_s << ','
      str << '32400,'
      str << '0,'
      str << h['linkURI'].gsub(/[,\\]/) { "\\#$&" } << ','
      str << h['title'].to_s.gsub(/[,\\]/) { "\\#$&" }.strip.gsub(/\s/, ' ') << ','
      str << (h['author'].to_s || '0').gsub(/[,\\]/) { "\\#$&" }.strip.gsub(/\s/, ' ') << ','
      str << '0,'
      str << "\n"
    }
    str = str.encode_charset('euc-jp')
    str = str.encode_gzip

    output_file(@opt_output_lirs, str)
  end


end

if $0 == __FILE__
  Samidare.new.main
end


